Index: /trunk/VUT/GtpVisibilityPreprocessor/scripts/default.env
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/scripts/default.env	(revision 335)
+++ /trunk/VUT/GtpVisibilityPreprocessor/scripts/default.env	(revision 344)
@@ -8,6 +8,6 @@
 #	filename glasgow1.x3d
 #	filename vienna.x3d
-#	filename ../data/vienna/vienna-simple.x3d
-	filename ../data/vienna/vienna-buildings.x3d
+	filename ../data/vienna/vienna-simple.x3d
+#	filename ../data/vienna/vienna-buildings.x3d
 #	filename ../data/vienna/viewcells-25-sel.x3d
 #	filename ../data/atlanta/atlanta2.x3d
@@ -56,5 +56,5 @@
 
 Sampling {
-	totalSamples	1000000
+	totalSamples	100
 	samplesPerPass  20
 }
@@ -69,6 +69,6 @@
 	
 #	filename ../data/atlanta/atlanta_viewcells_large.x3d
-	filename ../data/vienna/viewcells-25-sel.x3d
-#	filename ../data/vienna/viewcells-25.x3d
+#	filename ../data/vienna/viewcells-25-sel.x3d
+	filename ../data/vienna/viewcells-25.x3d
 #	filename ../data/vienna/viewcells-large-sel.x3d
 }
@@ -76,9 +76,9 @@
 BspTree {
 	Construction {
-		input fromRays
-	#	input fromViewCells
+	#	input fromRays
+		input fromViewCells
 	#	input fromSceneGeometry
 		samples 200000
-		sideTolerance 0.002
+		sideTolerance 0.005
 	}
 
@@ -113,5 +113,5 @@
 	#splitPlaneStrategy 130
 	
-	splitPlaneStrategy 130
+	splitPlaneStrategy 66
 	
 	maxCandidates 50
@@ -120,9 +120,9 @@
 		# autopartition
 		maxRays -1
-		maxPolygons 20
+		maxPolygons 0
 		maxDepth 100
 		
 		#axis aligned split
-		maxPolysForAxisAligned 200
+		maxPolysForAxisAligned 100
 		maxCostRatio 0.9
 		ct_div_ci 0.5
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellBsp.h
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellBsp.h	(revision 342)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellBsp.h	(revision 344)
@@ -598,5 +598,5 @@
 	/// view cell corresponding to unbounded space
 	ViewCell *mRootCell;
-
+	/// should view cells be stored or generated in the leaves?
 	bool mGenerateViewCells;
 
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/main.cpp
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/main.cpp	(revision 335)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/main.cpp	(revision 344)
@@ -101,5 +101,5 @@
   }
 
-  if (1) {
+  if (0) {
     Camera camera;
     //camera.LookAtBox(p->mKdTree->GetBox());
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/Polygon3.cpp
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/Polygon3.cpp	(revision 329)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/Polygon3.cpp	(revision 344)
@@ -169,5 +169,5 @@
 		// 3 vertices enough to decide coincident
 		else if (((++ count) >= 3) && !onFrontSide && !onBackSide)
-		{   
+		{   //if (DotProd(plane.mNormal, GetNormal()) > 0)
 			return Plane3::COINCIDENT; 
 		}
@@ -182,5 +182,5 @@
 		return Plane3::FRONT_SIDE;
 	}
-
+	//if (DotProd(plane.mNormal, GetNormal()) < 0) return Plane3::FRONT_SIDE;
 	return Plane3::COINCIDENT; // plane and polygon are coincident
 }
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/SamplingPreprocessor.cpp
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/SamplingPreprocessor.cpp	(revision 341)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/SamplingPreprocessor.cpp	(revision 344)
@@ -579,5 +579,5 @@
     delete exporter;
   }
-  
+  //-- several visualizations and statistics
   if (1) {
   if (mViewCellsType == BSP_VIEW_CELLS)
@@ -606,5 +606,6 @@
 			  exporter->ResetForcedMaterial();
 
-			  if (1)
+			  // export scene geometry
+			  if (0)
 			  {
 				  Material m;//= RandomMaterial();
@@ -654,5 +655,5 @@
 		  exporter->SetForcedMaterial(m);
 
-		  // output pvs of view cell
+		  // output PVS of view cell
 		  for (; it != vc->GetPvs().mEntries.end(); ++ it) 
 		  {
@@ -665,6 +666,6 @@
 		  }
 		
-		  // output rest of the objects
-		  if (1)
+		  // output rest of the sobjects
+		  if (0)
 		  {
 			  Material m;//= RandomMaterial();